package de.zimkand.brdemo;

import android.content.Intent;
import android.content.IntentFilter;
import android.os.BatteryManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {
    private DynamicReceiver dynamicReceiver;
    private IntentFilter intentFilter;
    private Button btnSend, btnBattery;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        dynamicReceiver = new DynamicReceiver();
        intentFilter = new IntentFilter(Intent.ACTION_POWER_DISCONNECTED);
        btnSend = findViewById(R.id.btnSend);
        btnSend.setOnClickListener(this);
        btnBattery = findViewById(R.id.btnBattery);
        btnBattery.setOnClickListener(this);

        registerReceiver(dynamicReceiver,
                new IntentFilter("de.zimkand.intent.action.FINITO"),
                "de.zimkand.permission.BROADCAST", null);
    }

//    @Override
//    protected void onResume() {
//        super.onResume();
//        registerReceiver(dynamicReceiver, intentFilter);
//    }

//    @Override
//    protected void onPause() {
//        super.onPause();
//        unregisterReceiver(dynamicReceiver);
//    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        unregisterReceiver(dynamicReceiver);
    }

    @Override
    public void onClick(View v) {
        if (v == btnSend) {
            sendBroadcast(new Intent("de.zimkand.intent.action.FINITO"));
        } else {
            // Quelle: https://developer.android.com/training/monitoring-device-state/battery-monitoring.html
            Intent batteryIntent = this.registerReceiver(null, new IntentFilter(Intent.ACTION_BATTERY_CHANGED));
            int level = batteryIntent.getIntExtra(BatteryManager.EXTRA_LEVEL, -1);
            int scale = batteryIntent.getIntExtra(BatteryManager.EXTRA_SCALE, -1);
            float batteryPct = (level/(float)scale)*100;
            Toast.makeText(this, "Battery Status in Percent: "+Float.toString(batteryPct), Toast.LENGTH_LONG).show();
        }
    }
}

