package de.zimkand.eventdiary;

import android.content.ContentUris;
import android.content.ContentValues;
import android.database.Cursor;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.*;

public class EditEventActivity extends AppCompatActivity {

    private boolean insertMode = true;
    private long rowid;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_edit_event);

        final RadioGroup radioGroup = findViewById(R.id.radioGroup);
        Button btnEvent = findViewById(R.id.btnEvent);
        EditText event = findViewById(R.id.etEvent);

        int colEventDesc = 2, colMood = 3;

        Bundle extras = getIntent().getExtras();
        if (extras != null) {
            insertMode = false;
            rowid = extras.getLong("rowid");
            event.setText(extras.getString("desc"));
            int mood = extras.getInt("mood");
            ((RadioButton) radioGroup.getChildAt(mood - 1)).setChecked(true);
            btnEvent.setText(getString(R.string.update_event));
        } else
            this.setTitle(getString(R.string.title_activity_new_event));

        btnEvent.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                EditText event = findViewById(R.id.etEvent);
                String s = event.getText().toString();
                int rbId = radioGroup.getCheckedRadioButtonId();
                View rb = radioGroup.findViewById(rbId);
                int mood = radioGroup.indexOfChild(rb) + 1;
                if (s.length() > 0 && mood >= 1 && mood <= 5) {
                    ContentValues values = new ContentValues();
                    values.put(EventProvider.COL_DESC, event.getText().toString());
                    values.put(EventProvider.COL_MOOD, mood);
                    if (insertMode) {
                        values.put(EventProvider.COL_DATETIME, System.currentTimeMillis());
                        getContentResolver().insert(EventProvider.CONTENT_URI, values);
                        radioGroup.clearCheck();
                        event.setText("");
                    } else {
                        getContentResolver().update(ContentUris.withAppendedId(EventProvider.CONTENT_URI, rowid), values, null, null);
                        finish();
                    }
                } else
                    Toast.makeText(EditEventActivity.this, R.string.uncomplete, Toast.LENGTH_SHORT).show();
            }
        });
    }
}
