package de.zimkand.eventdiary;

import android.arch.persistence.room.*;
import android.content.ContentValues;

import java.util.Date;

@Entity(tableName = "events")
public class Event {

    @PrimaryKey(autoGenerate = true)
    @ColumnInfo(name = "_id")
    private long id;

    @ColumnInfo(name = "datetime")
    private Date dateTime;

    private String desc;

    private int mood;

    public Event() {}

    public long getId() {
        return id;
    }
    public void setId(long id) {
        this.id = id;
    }

    public Date getDateTime() {
        return dateTime;
    }
    public void setDateTime(Date dateTime) {
        this.dateTime = dateTime;
    }

    public String getDesc() {
        return desc;
    }
    public void setDesc(String event) {
        this.desc = event;
    }

    public int getMood() {
        return mood;
    }
    public void setMood(int mood) {
        this.mood = mood;
    }

    public void setValues(ContentValues values) {
        if (values.containsKey(EventProvider.COL_DATETIME)) {
            dateTime = new Date(values.getAsLong(EventProvider.COL_DATETIME));
        }
        if (values.containsKey(EventProvider.COL_DESC)) {
            desc = values.getAsString(EventProvider.COL_DESC);
        }
        if (values.containsKey(EventProvider.COL_MOOD)) {
            mood = values.getAsInteger(EventProvider.COL_MOOD);
        }
    }

    public static Event fromContentValues(ContentValues values) {
        Event event = new Event();
        event.setValues(values);
        return event;
    }
}
