package de.zimkand.eventdiary;

import android.arch.persistence.room.*;
import android.database.Cursor;

import java.util.List;

@Dao
public interface EventDAO {
    @Query("SELECT * FROM events")
    List<Event> getEvents();

    @Query("SELECT * FROM events WHERE _id = :rowid")
    Event getEvent(long rowid);

    @Query("SELECT * FROM events")
    Cursor selectAll();

    @Query("SELECT * FROM events WHERE _id = :rowid")
    Cursor selectById(long rowid);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void insert(Event... events);

    @Update
    int update(Event... events);

    @Delete
    void delete(Event... events);

    @Query("DELETE FROM " + EventProvider.TABLE_EVENTS + " WHERE " + EventProvider.COL_ID + " = :rowid")
    int deleteById(long rowid);
}
