package de.zimkand.eventdiary;

import android.content.Context;
import android.database.Cursor;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.support.v4.widget.CursorAdapter;
import android.widget.TextView;
import java.text.SimpleDateFormat;
import java.util.Date;

public class EventDiaryAdapter extends CursorAdapter {

    private final Date date = new Date();
    private SimpleDateFormat sdf = new SimpleDateFormat("EEE, dd MMM yyyy, HH:mm:ss");
    private LayoutInflater inflator;
    private int colDateTime = 1, colEventDesc = 2, colMood = 3;

    public EventDiaryAdapter(Context context, Cursor c) {
        super(context, c, 0);
        // Das Flag CursorAdapter.FLAG_REGISTER_CONTENT_OBSERVER ist überflüssig.
        inflator = LayoutInflater.from(context);
    }

    @Override
    public View newView(Context context, Cursor cursor, ViewGroup parent) {
        return inflator.inflate(R.layout.entry, null);
    }

    @Override
    public void bindView(View view, Context context, Cursor cursor) {
        TextView tvDateTime = view.findViewById(R.id.dateTime);
        TextView tvMood = view.findViewById(R.id.moodValue);
        TextView tvDesc = view.findViewById(R.id.eventDesc);
        long timeMillis = cursor.getLong(colDateTime);
        date.setTime(timeMillis);
        tvDateTime.setText(sdf.format(date));
        tvMood.setText(context.getString(R.string.moodvalue) + " " + Integer.toString(cursor.getInt(colMood)));
        tvDesc.setText(cursor.getString(colEventDesc));
    }
}
