/*
 * Copyright (C) 2010 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// Vorlage: https://developer.android.com/guide/components/fragments.html

package de.zimkand.fragmentdemo;

import android.content.res.Configuration;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;

public class DetailsActivity extends AppCompatActivity {
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        if (getResources().getConfiguration().orientation == Configuration.ORIENTATION_LANDSCAPE) {
            finish();
            return;
        }

        DetailsFragment details;
        if (savedInstanceState == null) {
            details = DetailsFragment.newInstance(getIntent().getExtras().getInt("index", 0));
            getSupportFragmentManager().beginTransaction()
                    .add(android.R.id.content, details, "defrag").commit();
//            Log.i("Fragment ", "new");
        } else {
            details = (DetailsFragment) getSupportFragmentManager().findFragmentByTag("defrag");
//            Log.i("Fragment ", "was recreated");
        }

        setTitle(getTitle() +
                " ("+getResources().getStringArray(R.array.titles)[details.getShownIndex()]+")");
    }
}

