package de.zimkand.implintent;

import android.content.Intent;
import android.database.Cursor;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.net.Uri;
import android.provider.ContactsContract;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity {
    private int REQUEST_CODE_PICK = 13;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        // Kontakte anzeigen (ACTION_VIEW)
        Button btnViewContacts = (Button) findViewById(R.id.viewContacts);
        if (btnViewContacts != null)
            btnViewContacts.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View v) {
                    // Alle Kontakte anzeigen
                    Intent abook = new Intent(Intent.ACTION_VIEW, ContactsContract.Contacts.CONTENT_URI);
                    //				Intent abook = new Intent(Intent.ACTION_VIEW, Uri.parse("content://com.android.contacts/contacts"));
                    //              Intent abook = new Intent();
                    //              abook.setAction(Intent.ACTION_VIEW);
                    //              abook.setData(ContactsContract.Contacts.CONTENT_URI);

                    if (abook.resolveActivity(getPackageManager()) != null)
                        startActivity(abook);

                    // Den Kontakt mit ID 1 anzeigen
                    //				Intent abook1 = new Intent(Intent.ACTION_VIEW, Uri.parse("content://com.android.contacts/contacts/1"));
                    //				startActivity(abook1);

                    // Versuch, die "Power"-Kontakte anzuzeigen
                    //				Intent powerContacts = new Intent(Intent.ACTION_POWER_CONNECTED, ContactsContract.Contacts.CONTENT_URI);
                    //				if (powerContacts.resolveActivity(getPackageManager()) != null)
                    //					startActivity(powerContacts);
                }
            });

        // Kontakt mit Extra-Daten einfügen (ACTION_INSERT)
        Button btnInsertContact = (Button) findViewById(R.id.insertContact);
        if (btnInsertContact != null)
            btnInsertContact.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View v) {
                    Intent newContact = new Intent(Intent.ACTION_INSERT, ContactsContract.Contacts.CONTENT_URI);
                    newContact.putExtra(ContactsContract.Intents.Insert.NAME, "Kurt Saar");
                    if (newContact.resolveActivity(getPackageManager()) != null)
                        startActivity(newContact);
                }
            });


        // Kontakt wählen (ACTION_PICK)
        Button btnSelectContact = (Button) findViewById(R.id.selectContact);
        if (btnSelectContact != null)
            btnSelectContact.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View v) {
                    Intent intent = new Intent(Intent.ACTION_PICK, ContactsContract.Contacts.CONTENT_URI);
                    if (intent.resolveActivity(getPackageManager()) != null)
                        startActivityForResult(intent, REQUEST_CODE_PICK);
                }
            });


        // Homepage der Uni Trier im Browser anzeigen
        Button btnViewUT = findViewById(R.id.viewUT);
        if (btnViewUT != null)
            btnViewUT.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View v) {
                    Intent viewUT = new Intent(Intent.ACTION_VIEW, Uri.parse("https://www.uni-trier.de/"));
                    if (viewUT.resolveActivity(getPackageManager()) != null)
                        startActivity(viewUT);

//                    // Chooser erscheint nicht:
//                    Intent chooser = Intent.createChooser(viewUT, getString(R.string.title_chooser));
//                    startActivity(chooser);
                }
            });

        // Text versenden mit wählbarer Aktivität
        Button btnChooser = findViewById(R.id.btnChooser);
        if (btnChooser != null)
            btnChooser.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View v) {
                    Intent sendIntent = new Intent();
                    sendIntent.setAction(Intent.ACTION_SEND);
                    sendIntent.putExtra(Intent.EXTRA_TEXT, "Please notice this message.");
                    sendIntent.setType("text/plain");
                    startActivity(Intent.createChooser(sendIntent, getText(R.string.title_chooser)));
//                    if (sendIntent.resolveActivity(getPackageManager()) != null)
//                        startActivity(sendIntent);
                }
            });
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent intent) {
        if (requestCode == REQUEST_CODE_PICK) {
            TextView tv = (TextView) findViewById(R.id.tvSelected);
            if (resultCode == RESULT_OK) {
                String[] projection = {ContactsContract.CommonDataKinds.Phone.DISPLAY_NAME};
                Cursor cursor = getContentResolver().query(intent.getData(), projection, null, null, null);
                cursor.moveToFirst();
                String name = cursor.getString(0);
                tv.setText(getString(R.string.selected) + " " + name);
                cursor.close();
            } else
                tv.setText(getString(R.string.selected) + " " + getString(R.string.neg_answer));
        }
    }
}
