package de.zimkand.memoryconsumer;

import android.app.ActivityManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.*;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {
    private String[][] as = new String[1000][];
    private int index = 0;
    private Runtime runtime = Runtime.getRuntime();
    private TextView tv;
    private ActivityManager am;
    private int memoryClass;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Button button = findViewById(R.id.button);
        tv = findViewById(R.id.tv);
        button.setOnClickListener(this);
        am = (ActivityManager) getSystemService(ACTIVITY_SERVICE);
        memoryClass = am.getMemoryClass();
        showMemory();
    }

    @Override
    public void onClick(View v) {
        String[] star = new String[100_000];
        for (int i = 0; i < 100_000; i++)
            star[i] = new String();
        as[index++] = star;
        showMemory();
    }

    private void showMemory() {
        long max = runtime.maxMemory()/1024;
        long total = runtime.totalMemory()/1024;
        long free = runtime.freeMemory()/1024;
        long consumed = (runtime.totalMemory() - runtime.freeMemory())/1024;
        tv.setText("Memory Class (MB): " + Long.toString(memoryClass) +
                 "\n\nMax Memory (KB): " + Long.toString(max) +
                 "\nTotal Memory (KB): " + Long.toString(total) +
                 "\nFree Memory (KB): " + Long.toString(free) +
                 "\n\nMemory consumed (KB): " + Long.toString(consumed));
    }
}
