package de.zimkand.primedetection;

import android.content.Context;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.TextView;

public class PrimeActivity extends AppCompatActivity implements View.OnClickListener {
    private EditText candidate;
    private TextView result;
    private Button button;
    private AsyncPrimeTask apt;
    private ProgressBar progressBar;

    // 8 MByte Speicherverschwendung
//    private long[] memLoad = new long[1048576];

    private class AsyncPrimeTask extends AsyncTask<String, Integer, String> {

        private Context context = PrimeActivity.this;

        @Override
        protected void onPreExecute() {
            result.setText("");
            button.setEnabled(false);
            progressBar.setVisibility(ProgressBar.VISIBLE);
            progressBar.setProgress(0);
        }

        @Override
        protected String doInBackground(String... arg) {
            boolean df = false;
            long cand, i, mdc, widthSeg;
            int nSeg = 100;
            if (arg[0].length() == 0)
                return null;
            cand = Long.parseLong(arg[0]);
            mdc = (int) Math.sqrt(cand);
            widthSeg = Math.max(10_000, mdc/nSeg);
            for (i = 2; i <= mdc; i++) {
                if (this.isCancelled())
                    return null;
                if (i%widthSeg == 0)
                    publishProgress((int)(i/(float)mdc*100));
                if (cand % i == 0) {
                    df = true;
                    break;
                }
            }
            if (cand <= 1)
                return arg[0] + " " + context.getString(R.string.falseArgument);
            else
            if (df)
                return arg[0] + " " + context.getString(R.string.noPrime) + "\n(" +
                        context.getString(R.string.divisor) + Long.toString(i)+ ")";
            else
                return arg[0] + " " + context.getString(R.string.prime);
        }

        @Override
        protected void onProgressUpdate(Integer... progress) {
            progressBar.setProgress(progress[0]);
        }

        @Override
        protected void onPostExecute(String res) {
            if (res != null)
                result.setText(res);
            progressBar.setVisibility(ProgressBar.GONE);
            button.setEnabled(true);
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_prime);

        button = findViewById(R.id.button);
        button.setOnClickListener(this);
        candidate = findViewById(R.id.candidate);
        result = findViewById(R.id.result);
        progressBar = findViewById(R.id.progressBar);

        // Anzahl der Threads und Speicherverbrauch im logcat-Fenster protokollieren
//        String TAG = this.getClass().getSimpleName();
//        Runtime runtime = Runtime.getRuntime();
//        int numberOfThreads = Thread.getAllStackTraces().keySet().size();
//        long consumed = (runtime.totalMemory() - runtime.freeMemory())/1048576;
//        Log.i(TAG, "Number of Threads = " + String.valueOf(numberOfThreads) +
//                " Used Memory (MB) = " + String.valueOf(consumed));
    }

//    @Override
//    protected void onResume() {
//        super.onResume();
//        candidate.setText("981168724994134051");
//    }

    @Override
    public void onClick(View view) {
        String s = candidate.getText().toString();
        if (s.length() != 0) {
            apt = new AsyncPrimeTask();
            apt.execute(s);
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (apt != null)
            apt.cancel(true);
    }
}
