package de.zimkand.primedetection;

import android.os.Bundle;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class PrimeActivity extends AppCompatActivity implements View.OnClickListener {
    private EditText candidate;
    private TextView result;
    private Button button;
    private Thread t;
    private Handler h = new Handler();

//    // 8 MByte Speicherverschwendung
//    private long[] memLoad = new long[1048576];

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_prime);

        button = findViewById(R.id.button);
        button.setOnClickListener(this);

        candidate = findViewById(R.id.candidate);
        result = findViewById(R.id.result);

//        // Anzahl der Threads und Speicherverbrauch im logcat-Fenster protokollieren
//        String TAG = this.getClass().getSimpleName();
//        Runtime runtime = Runtime.getRuntime();
//        int numberOfThreads = Thread.getAllStackTraces().keySet().size();
//        long consumed = (runtime.totalMemory() - runtime.freeMemory())/1048576;
//        Log.i(TAG, "Number of Threads = " + String.valueOf(numberOfThreads) +
//              " Used Memory (MB) = " + String.valueOf(consumed));
    }

    @Override
    public void onClick(View view) {
        button.setEnabled(false);
        t = new Thread() {
            @Override
            public void run() {
                android.os.Process.setThreadPriority(android.os.Process.THREAD_PRIORITY_BACKGROUND);
                String sCandidate = candidate.getText().toString();
                final String sResult;
                boolean df = false;
                long cand, i, mdc;

                if (sCandidate.length() == 0)
                    return;
                cand = Long.parseLong(sCandidate);
                mdc = (int) Math.sqrt(cand);
                for (i = 2; i <= mdc; i++) {
                    if (Thread.currentThread().isInterrupted())
                        return;
                    if (cand % i == 0) {
                        df = true;
                        break;
                    }
                }
                if (cand <= 1)
                    sResult = sCandidate + " " + getString(R.string.falseArgument);
                else
                if (df)
                    sResult = sCandidate + " " + getString(R.string.noPrime) + "\n(" +
                            getString(R.string.divisor) + Long.toString(i)+ ")";
                else
                    sResult = sCandidate + " " + getString(R.string.prime);

                h.post(new Runnable() {
                    @Override
                    public void run() {
                        result.setText(sResult);
                        button.setEnabled(true);
                    }
                });

//                PrimeActivity.this.runOnUiThread(new Runnable() {
//                    @Override
//                    public void run() {
//                        result.setText(sResult);
//                        button.setEnabled(true);
//                    }
//                });
//
//                result.post(new Runnable() {
//                    @Override
//                    public void run() {
//                        result.setText(sResult);
//                        button.setEnabled(true);
//                    }
//
//                });
            }
        };
        t.start();
    }

//    @Override
//    protected void onResume() {
//        super.onResume();
//        candidate.setText("981168724994134051");
//    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (t != null)
            t.interrupt();
    }
}
