package de.zimkand.eventdiary;

import android.arch.persistence.room.*;
import android.content.Context;

@Database(entities = {Event.class}, version = 1)
@TypeConverters({DateLongConverter.class})
public abstract class EventDatabase extends RoomDatabase {
    private static EventDatabase instance;

    public abstract EventDAO getEventDAO();

    public static synchronized EventDatabase getInstance(Context context) {
        if (instance == null) {
            instance = Room.databaseBuilder(context, EventDatabase.class, "eventdiary.db")
                    .allowMainThreadQueries()
                    .build();
        }
        return instance;
    }
}
