package de.zimkand.eventdiary;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.*;
import java.util.Date;

public class NewEventActivity extends AppCompatActivity {

    private EventDAO eventDAO;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_new_event);
        final RadioGroup radioGroup = findViewById(R.id.radioGroup);
        eventDAO = MainActivity.getEventDAO();

        Button btnAddEvent = findViewById(R.id.btnAddEvent);
        btnAddEvent.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                EditText desc = findViewById(R.id.etDesc);
                String s = desc.getText().toString();
                int rbId = radioGroup.getCheckedRadioButtonId();
                View rb = radioGroup.findViewById(rbId);
                int mood = radioGroup.indexOfChild(rb) + 1;
                if (s.length() > 0  &&  mood >= 1  &&  mood <= 5) {
                    eventDAO.insert(new Event(new Date(), s, mood));
                    radioGroup.clearCheck();
                    desc.setText("");
                } else
                    Toast.makeText(NewEventActivity.this, R.string.incomplete, Toast.LENGTH_SHORT).show();
            }
        });
    }
}
