package de.zimkand.eventdiary;

import android.arch.persistence.room.*;
import java.util.List;

@Dao
public interface EventDAO {
    @Query("SELECT * FROM events")
    List<Event> getEvents();

    @Query("SELECT * FROM events WHERE eventid = :rowid")
    Event getEvent(long rowid);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void insert(Event... events);

    @Update
    void update(Event... events);

    @Delete
    void delete(Event... events);
}
