package de.zimkand.eventdiary;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import java.util.Date;
import java.util.List;

public class EventListActivity extends AppCompatActivity implements AdapterView.OnItemClickListener {

    EventArrayAdapter adapter;
    private final int REQUEST_CODE_EDIT = 1;
    private EventDAO eventDAO;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_event_list);

        eventDAO = MainActivity.getEventDAO();
        List<Event> allEvents = eventDAO.getEvents();
        if (allEvents.size() == 0) {
            eventDAO.insert(new Event(new Date(), "5 Cent gefunden", 5));
            allEvents = eventDAO.getEvents();
        }
        adapter = new EventArrayAdapter(this, R.layout.event, allEvents);
        ListView lv = findViewById(R.id.listView);
        lv.setAdapter(adapter);
        lv.setOnItemClickListener(this);
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        Event event = (Event)adapter.getItem(position);
        editEntry(event, position);
    }

    private void editEntry(Event event, int position) {
        Intent intent = new Intent(this, EditEventActivity.class);
        intent.putExtra("event", event);
        intent.putExtra("position", position);
        startActivityForResult(intent, REQUEST_CODE_EDIT);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent intent) {
        if (requestCode == REQUEST_CODE_EDIT && resultCode== RESULT_OK && intent != null) {
            Bundle extras = intent.getExtras();
            int position = extras.getInt("position");
            Event event = (Event) adapter.getItem(position);
            event.setDesc(extras.getString("desc"));
            event.setMood(extras.getInt("mood"));
            adapter.notifyDataSetChanged();
        }
    }
}
