package de.zimkand.eventdiary;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.*;
import java.util.Date;

public class EditEventActivity extends AppCompatActivity {

    private EventDAO eventDAO;
    private boolean insertMode = true;
    private int position;
    private Event event;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_edit_event);
        final RadioGroup radioGroup = findViewById(R.id.radioGroup);
        EditText desc = findViewById(R.id.etDesc);
        Button btnEvent = findViewById(R.id.btnEvent);

        eventDAO = MainActivity.getEventDAO();

        Bundle extras = getIntent().getExtras();
        if (extras != null) {
            insertMode = false;
            event = (Event) extras.getSerializable("event");
            position = extras.getInt("position");
            desc.setText(event.getDesc());
            int mood = event.getMood();
            ((RadioButton) radioGroup.getChildAt(mood - 1)).setChecked(true);
        } else {
            this.setTitle(getString(R.string.title_activity_new_event));
            btnEvent.setText(getString(R.string.add_event));
        }

        btnEvent.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                EditText desc = findViewById(R.id.etDesc);
                String s = desc.getText().toString();
                int rbId = radioGroup.getCheckedRadioButtonId();
                View rb = radioGroup.findViewById(rbId);
                int mood = radioGroup.indexOfChild(rb) + 1;
                if (s.length() > 0  &&  mood >= 1  &&  mood <= 5) {
                    if (insertMode) {
                        eventDAO.insert(new Event(new Date(), s, mood));
                        radioGroup.clearCheck();
                        desc.setText("");
                    } else {
                        event.setDesc(s);
                        event.setMood(mood);
                        eventDAO.update(event);
                        Intent intent = new Intent();
                        intent.putExtra("position", position);
                        intent.putExtra("desc", s);
                        intent.putExtra("mood", mood);
                        setResult(RESULT_OK, intent);
                        finish();
                    }
                } else
                    Toast.makeText(EditEventActivity.this, R.string.incomplete, Toast.LENGTH_SHORT).show();
            }
        });
    }
}
