package de.zimkand.eventdiary;

import android.content.Context;
import android.view.*;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

public class EventArrayAdapter extends ArrayAdapter<Event> {
    private SimpleDateFormat sdf = new SimpleDateFormat("EEE, dd MMM yyyy, HH:mm:ss");
    private List<Event> events;
    private Context context;
    private int layout;

    public EventArrayAdapter(Context context, int layout, List<Event> events) {
        super(context, layout, events);
        this.context = context;
        this.layout = layout;
        this.events = events;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        // Das darzustellende Ereignis
        Event event = events.get(position);
        // Bei Bedarf das Layout inflationieren
        if (convertView == null)
            convertView = LayoutInflater.from(context).inflate(layout, null);
        // Aktuelle Ereignisdaten in die TextView-Elemente übertragen
        TextView tvDateTime = convertView.findViewById(R.id.dateTime);
        TextView tvMood = convertView.findViewById(R.id.moodValue);
        TextView tvDesc = convertView.findViewById(R.id.eventDesc);
        Date date = event.getDateTime();
        tvDateTime.setText(sdf.format(date));
        tvMood.setText(context.getString(R.string.moodvalue) + " " + String.valueOf(event.getMood()));
        tvDesc.setText(event.getDesc());
        return convertView;
    }
}
