package de.zimkand.primedetection;

import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.support.v4.content.LocalBroadcastManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.TextView;

public class PrimeActivity extends AppCompatActivity implements View.OnClickListener {
    private EditText candidate;
    private TextView result;
    private Button button;
    private ProgressBar progressBar;
    private PrimeEvalReceiver receiver;
    public static final String BROADCAST_ACTION = "de.zimkand.primedetection.action.BROADCAST_ACTION";

//    // 8 MByte Speicherverschwendung
//    private long[] memLoad = new long[1048576];
//    static String TAG = "PrimeActivity";

    private class PrimeEvalReceiver extends BroadcastReceiver {
        @Override
        public void onReceive(Context context, Intent intent) {
            Bundle bundle = intent.getExtras();
            float progress = bundle.getFloat("progress");
            if (progress != 0.0f) {
                button.setEnabled(false);
                progressBar.setVisibility(ProgressBar.VISIBLE);
                progressBar.setProgress((int)progress);
                return;
            }
            String ergebnis = bundle.getString("result");
            result.setText(ergebnis);
            button.setEnabled(true);
            progressBar.setVisibility(ProgressBar.GONE);
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_prime);
        button = findViewById(R.id.button);
        button.setOnClickListener(this);
        candidate = findViewById(R.id.candidate);
        result = findViewById(R.id.result);
        progressBar = findViewById(R.id.progressBar);
        receiver = new PrimeEvalReceiver();
        IntentFilter intentFilter = new IntentFilter(BROADCAST_ACTION);
        LocalBroadcastManager.getInstance(this).registerReceiver(receiver, intentFilter);
    }

//    // Sehr große Primzahl automatisch als Aufgabe stellen
//    @Override
//    protected void onResume() {
//        super.onResume();
//        candidate.setText("981168724994134051");
//    }

    @Override
    public void onClick(View arg0) {
        String s = candidate.getText().toString();
        result.setText("");
        button.setEnabled(false);
        progressBar.setProgress(0);
        progressBar.setVisibility(ProgressBar.VISIBLE);
        Intent intent = new Intent(this, PrimeIntentService.class);
        intent.putExtra("CAND", candidate.getText().toString());
        startService(intent);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        LocalBroadcastManager.getInstance(this).unregisterReceiver(receiver);
//        // Nicht möglich bei IntentService
//        if (!isChangingConfigurations()) {
//            stopService(new Intent(this, PrimeIntentService.class));
//        }
    }
}
