package de.zimkand.primedetection;

import android.app.IntentService;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.content.LocalBroadcastManager;
import android.util.Log;

public class PrimeIntentService extends IntentService {

    static String TAG = "PrimeActivity";

    public PrimeIntentService() {
        super("PrimeIntentService");
    }

    @Override
    protected void onHandleIntent(Intent intent) {
        Log.i(TAG, "Gruppe = "+String.valueOf(Thread.currentThread().getThreadGroup()));
        Log.i(TAG, "Priorität = "+String.valueOf(Thread.currentThread().getPriority()));

        String strCand = intent.getExtras().getString("CAND");
        Context context = this;
        LocalBroadcastManager locBcMan = LocalBroadcastManager.getInstance(this);
        Intent returnIntent = new Intent(PrimeActivity.BROADCAST_ACTION);
        Bundle messBundle = new Bundle();

        boolean df = false;
        long cand, i, mdc, widthSeg;
        int nSeg = 100;
        if (strCand.length() == 0)
            return;
        cand = Long.parseLong(strCand);
        mdc = (int) Math.sqrt(cand);
        widthSeg = Math.max(1000, mdc/nSeg);
        for (i = 2; i <= mdc; i++) {
            if (i%widthSeg == 0) {
                messBundle.putFloat("progress", i/(float)mdc*100);
                returnIntent.putExtras(messBundle);
                locBcMan.sendBroadcast(returnIntent);
            }
            if (cand % i == 0) {
                df = true;
                break;
            }
        }
        String res;
        if (cand <= 1)
            res = strCand + " " + context.getString(R.string.falseArgument);
        else if (df)
            res = strCand + " " + context.getString(R.string.noPrime) + "\n(" +
                    context.getString(R.string.divisor) + Long.toString(i)+ ")";
        else
            res = strCand + " " + context.getString(R.string.prime);
        messBundle.putFloat("progress", 0.0f);
        messBundle.putString("result", res);
        returnIntent.putExtras(messBundle);
        locBcMan.sendBroadcast(returnIntent);
    }
}
