package de.zimkand.primedetection;

import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.Binder;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.Process;
import android.support.v4.content.LocalBroadcastManager;
import android.util.Log;

public class PrimeServiceBound extends Service implements Runnable {
    private String cand;
    private Thread t;
    private boolean running = false;
    static String TAG = "PrimeActivity";

    public class PrimeBinder extends Binder {
        public PrimeServiceBound getService() {
            return PrimeServiceBound.this;
        }
    }

    @Override
    public IBinder onBind(Intent intent) {
        return new PrimeBinder();
    }

    @Override
    public void onDestroy() {
        if (t != null)
            t.interrupt();
    }

    public boolean evalCandidate(String cand) {
        if (running)
            return false;
            else {
            this.cand = cand;
            t = new Thread(this);
            t.start();
            return true;
        }
    }

    public boolean isRunning() {
        return running;
    }

    @Override
    public void run() {
//        Thread.currentThread().setPriority(10);
//        Log.i(TAG, "Gruppe = "+String.valueOf(Thread.currentThread().getThreadGroup()));
//        Log.i(TAG, "Priorität = "+String.valueOf(Thread.currentThread().getPriority()));

        Context context = this;
        LocalBroadcastManager locBcMan = LocalBroadcastManager.getInstance(this);
        Intent returnIntent = new Intent(PrimeActivity.BROADCAST_ACTION);
        Bundle messBundle = new Bundle();

        running = true;
        Bundle bundle = new Bundle();
        Message message;
        boolean df = false;
        long cand, i, mdc, widthSeg;
        int nSeg = 100;
        if (this.cand.length() == 0)
            return;
        cand = Long.parseLong(this.cand);
        mdc = (int) Math.sqrt(cand);
        widthSeg = Math.max(1000, mdc / nSeg);
        for (i = 2; i <= mdc; i++) {
            if (Thread.currentThread().isInterrupted())
                return;
            if (i % widthSeg == 0) {
                messBundle.putFloat("progress", i/(float)mdc*100);
                returnIntent.putExtras(messBundle);
                locBcMan.sendBroadcast(returnIntent);
            }
            if (cand % i == 0) {
                df = true;
                break;
            }
        }
        String res;
        if (cand <= 1)
            res = this.cand + " " + getString(R.string.falseArgument);
        else if (df)
            res = this.cand + " " + getString(R.string.noPrime) + "\n(" +
                    getString(R.string.divisor) + Long.toString(i) + ")";
        else
            res = this.cand + " " + getString(R.string.prime);
        messBundle.putFloat("progress", 0.0f);
        messBundle.putString("result", res);
        returnIntent.putExtras(messBundle);
        locBcMan.sendBroadcast(returnIntent);
        running = false;
    }
}
