package de.zimkand.checkradio;

import android.graphics.Typeface;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.RadioButton;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.ToggleButton;

public class CheckRadioActivity extends AppCompatActivity implements CompoundButton.OnCheckedChangeListener {
    private ToggleButton toggleBold;
    private Switch switchItalic;
    private RadioButton rbSans, rbSerif;
    private TextView tvSample;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_check_radio);

        tvSample = findViewById(R.id.tvSample);
        tvSample.setTypeface(Typeface.SANS_SERIF);

        rbSans = findViewById(R.id.rbSans);
        rbSerif = findViewById(R.id.rbSerif);
        rbSans.setOnCheckedChangeListener(this);
        rbSerif.setOnCheckedChangeListener(this);

        toggleBold = findViewById(R.id.toggleBold);
        switchItalic = findViewById(R.id.switchItalic);


        toggleBold.setOnCheckedChangeListener((cb, isChecked) -> {
                Typeface typeface = tvSample.getTypeface();
                int style = typeface.getStyle();
                Typeface actTFace = rbSans.isChecked() ? Typeface.SANS_SERIF : Typeface.SERIF;
                if (isChecked)
                    tvSample.setTypeface(actTFace, (style & Typeface.ITALIC) != 0 ? Typeface.BOLD_ITALIC : Typeface.BOLD);
                else
                    tvSample.setTypeface(actTFace, (style & Typeface.ITALIC) != 0 ? Typeface.ITALIC : Typeface.NORMAL);
        });


        switchItalic.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton cb, boolean isChecked) {
                Typeface typeface = tvSample.getTypeface();
                int style = typeface.getStyle();
                Typeface actTFace = rbSans.isChecked() ? Typeface.SANS_SERIF : Typeface.SERIF;
                if (isChecked)
                    tvSample.setTypeface(actTFace, (style & Typeface.BOLD) != 0 ? Typeface.BOLD_ITALIC : Typeface.ITALIC);
                else
                    tvSample.setTypeface(actTFace, (style & Typeface.BOLD) != 0 ? Typeface.BOLD : Typeface.NORMAL);
            }
        });
    }

    @Override
    public void onCheckedChanged(CompoundButton rb, boolean isChecked) {
        if (!isChecked)
            return;
        int style = tvSample.getTypeface().getStyle();
        if (rb == rbSans)
            tvSample.setTypeface(Typeface.SANS_SERIF, style);
        else
            tvSample.setTypeface(Typeface.SERIF, style);
    }
}
