package de.zimkand.numinput;

import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

public class MainActivity extends AppCompatActivity {
    EditText editText;
    Spinner spinner;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(de.zimkand.numinput.R.layout.activity_main);

        editText = (EditText) findViewById(de.zimkand.numinput.R.id.editText);

        String[] yearBirth = new String[101];
        yearBirth[0] = getString(R.string.spinner0);
        for (int i=1; i<=100; i++)
            yearBirth[i] = Integer.toString(i+1899);
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(this,
                android.R.layout.simple_dropdown_item_1line, yearBirth);
        spinner = (Spinner) findViewById(R.id.spinner);
        if (spinner != null)
            spinner.setAdapter(adapter);

        Button button = (Button) findViewById(R.id.button);
        if (button != null)
            button.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View v) {
                    // Check EditText
                    int year = -9;
                    String s = editText.getText().toString();
                    if (s.length() > 0)
                        year = Integer.parseInt(s);
                    if (!(year >= 1900  && year <2000)) {
                        AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                        builder.setMessage(R.string.acceptable);
                        AlertDialog dialog = builder.create();
                        dialog.show();
                    }
                    // Check Spinner
                    int position = spinner.getSelectedItemPosition();
                    if (position == 0) {
                        AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                        builder.setMessage(R.string.must_select);
                        AlertDialog dialog = builder.create();
                        dialog.show();
                    }
                }
            });
    }
}
