package de.zimkand.progressbardemo;

import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.ProgressBar;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {

    private ProgressBar progressBar;
    private Button button;
    private ProgressDemoTask task;

    private class ProgressDemoTask extends AsyncTask<String, Integer, String> {

        @Override
        protected void onPreExecute() {
            button.setEnabled(false);
            progressBar.setProgress(0);
            progressBar.setVisibility(ProgressBar.VISIBLE);
        }

        @Override
        protected String doInBackground(String... strings) {
            int i = 0;
            while (i < 100) {
                if (this.isCancelled())
                    return null;
                i++;
                try {
                    Thread.sleep(100);
                } catch(InterruptedException ie) {Thread.currentThread().interrupt();}
                publishProgress(i*1);
            }
            return null;
        }

        @Override
        protected void onProgressUpdate(Integer... progress) {
            progressBar.setProgress(progress[0]);
        }

        @Override
        protected void onPostExecute(String res) {
            progressBar.setVisibility(ProgressBar.GONE);
            button.setEnabled(true);
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        progressBar = findViewById(R.id.progressBar);
        button = findViewById(R.id.button);
        button.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        task = new  ProgressDemoTask();
        task.execute();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (task != null)
            task.cancel(true);
    }
}
