package de.zimkand.listview;

import android.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.view.menu.MenuBuilder;
import android.view.ContextMenu;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.*;

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        ListView lv = findViewById(R.id.list);

        String[] TITLES = {
                "Heinrich IV", "Alfons, der Viertel vor Zwölfte", "Heinrich V", "Ritter Kuno", "Heinrich VIII", "Richard II",
                "Richard III", "Oh, Bello", "Richard IV", "Richard V","Der Kaufmann aus Venedig", "Othello", "König Lear"
        };

        lv.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_activated_1, TITLES));
        lv.setVerticalScrollBarEnabled(true);
        lv.setOnItemClickListener(new ListView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> av, View v, int position, long id) {
                AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                builder.setMessage("Ihre Wahl: " + ((TextView)v).getText().toString());
                AlertDialog dialog = builder.create();
                dialog.show();
            }
        });

        registerForContextMenu(lv);

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.options_menu, menu);
        return true;
    }

    @Override
    public void onCreateContextMenu(ContextMenu contMenu, View v,
                                    ContextMenu.ContextMenuInfo contextMenuInfo) {
        super.onCreateContextMenu(contMenu, v, contextMenuInfo);
        getMenuInflater().inflate(R.menu.context_menu, contMenu);
    }

    @Override
    public boolean onContextItemSelected(MenuItem item) {
        AdapterView.AdapterContextMenuInfo acmi =
                (AdapterView.AdapterContextMenuInfo) item.getMenuInfo();
        switch (item.getItemId()) {
            case R.id.conit_edit:
                Toast.makeText(this, "Edit with "+String.valueOf(acmi.id),
                        Toast.LENGTH_SHORT).show();
                return true;
            case R.id.conit_del:
                Toast.makeText(this, "Del with "+String.valueOf(acmi.id),
                        Toast.LENGTH_SHORT).show();
                return true;
            default:
                return super.onContextItemSelected(item);
        }
    }

}
